/*
		A basic implementation of the JDialog class.
*/

package SesameGUI;
import java.awt.*;
import javax.swing.*;

public class JDialogAutoWindow extends javax.swing.JDialog
{
    private double STA=1.0;
    private double LTA=25.0;
    private double SEUILMIN=0.5;
    private double SEUILMAX=2.0;
    private double WIN_LENGTH=20;
    private double OVERLAP=10;
    private boolean SATURATION = true;
    private boolean TRANSIENT = false;
    private double TOLERANCE=0.0;
	public JDialogAutoWindow(Frame parent)
	{
		super(parent);
		
		// This code is automatically generated by Visual Cafe when you add
		// components to the visual environment. It instantiates and initializes
		// the components. To modify the code, only use code syntax that matches
		// what Visual Cafe can generate, or Visual Cafe may be unable to back
		// parse your Java file into its visual environment.
		//{{INIT_CONTROLS
		setTitle("Automatic Window Selection Parameters");
		getContentPane().setLayout(null);
		setSize(469,366);
		setVisible(false);
		JEditSTA.setText("1.0");
		getContentPane().add(JEditSTA);
		JEditSTA.setBounds(336,24,60,24);
		JEditLTA.setText("25.0");
		getContentPane().add(JEditLTA);
		JEditLTA.setBounds(336,60,60,24);
		JEditMinThreshold.setText("0.5");
		getContentPane().add(JEditMinThreshold);
		JEditMinThreshold.setBounds(336,96,60,24);
		JEditMaxThreshold.setText("2.0");
		getContentPane().add(JEditMaxThreshold);
		JEditMaxThreshold.setBounds(336,132,60,24);
		JEditWinLength.setText("20.0");
		getContentPane().add(JEditWinLength);
		JEditWinLength.setBounds(336,168,60,24);
		JLabel1.setText("Window length for the short term (sta) in sec: ");
		getContentPane().add(JLabel1);
		JLabel1.setBounds(36,24,300,24);
		JLabel2.setText("Window length for the long term (lta) in sec: ");
		getContentPane().add(JLabel2);
		JLabel2.setBounds(36,60,300,24);
		JLabel3.setText("Minimum level for sta/lta threshold:");
		getContentPane().add(JLabel3);
		JLabel3.setBounds(36,96,252,24);
		JLabel4.setText("Maximum level for sta/lta threshold:");
		getContentPane().add(JLabel4);
		JLabel4.setBounds(36,132,252,24);
		JLabel5.setText("Window length for selected windows in sec:");
		getContentPane().add(JLabel5);
		JLabel5.setBounds(36,168,252,24);
		JLabel6.setText("Overlap percentage for selected windows:");
		getContentPane().add(JLabel6);
		JLabel6.setBounds(36,204,252,24);
		JEditOverlap.setText("10");
		getContentPane().add(JEditOverlap);
		JEditOverlap.setBounds(336,204,60,24);
		JButtonOK.setText("OK");
		JButtonOK.setActionCommand("OK");
		getContentPane().add(JButtonOK);
		JButtonOK.setBounds(24,328,84,24);
		JButtonCancel.setText("Cancel");
		JButtonCancel.setActionCommand("Cancel");
		getContentPane().add(JButtonCancel);
		JButtonCancel.setBounds(348,328,84,24);
		JCheckBox1.setText("Saturation check:");
		JCheckBox1.setSelected(true);
		getContentPane().add(JCheckBox1);
		JCheckBox1.setBounds(36,280,144,24);
		JCheckBox2.setText("Removal of very noisy windows:");
		JCheckBox2.setSelected(false);
		getContentPane().add(JCheckBox2);
		JCheckBox2.setBounds(228,280,228,24);
    JLabel7.setText("Tolerance level for bad points (sec):");
		getContentPane().add(JLabel7);
		JLabel7.setBounds(36,244,252,24);
		JEditTolerance.setText("0.0");
    getContentPane().add(JEditTolerance);
		JEditTolerance.setBounds(336,244,60,24);
		//}}
	
		//{{REGISTER_LISTENERS
		SymAction lSymAction = new SymAction();
		JButtonOK.addActionListener(lSymAction);
		JButtonCancel.addActionListener(lSymAction);
		//}}
		setInitValues();
	}

   public JDialogAutoWindow(Frame frame,boolean modal)
	{
		this(frame);
		this.setModal(true);
	}
	
	public JDialogAutoWindow()
	{
		this((Frame)null);
	}

	public JDialogAutoWindow(String sTitle)
	{
		this();
		setTitle(sTitle);
	}

	public void setVisible(boolean b)
	{
		if (b)
			setLocation(50, 50);
		super.setVisible(b);
	}

	static public void main(String args[])
	{
		(new JDialogAutoWindow()).setVisible(true);
	}

	public void addNotify()
	{
		// Record the size of the window prior to calling parents addNotify.
		Dimension size = getSize();

		super.addNotify();

		if (frameSizeAdjusted)
			return;
		frameSizeAdjusted = true;

		// Adjust size of frame according to the insets
		Insets insets = getInsets();
		setSize(insets.left + insets.right + size.width, insets.top + insets.bottom + size.height);
	}

	// Used by addNotify
	boolean frameSizeAdjusted = false;

	//{{DECLARE_CONTROLS
	javax.swing.JTextField JEditSTA = new javax.swing.JTextField();
	javax.swing.JTextField JEditLTA = new javax.swing.JTextField();
	javax.swing.JTextField JEditMinThreshold = new javax.swing.JTextField();
	javax.swing.JTextField JEditMaxThreshold = new javax.swing.JTextField();
	javax.swing.JTextField JEditWinLength = new javax.swing.JTextField();
  javax.swing.JTextField JEditTolerance = new javax.swing.JTextField();
	javax.swing.JLabel JLabel1 = new javax.swing.JLabel();
	javax.swing.JLabel JLabel2 = new javax.swing.JLabel();
	javax.swing.JLabel JLabel3 = new javax.swing.JLabel();
	javax.swing.JLabel JLabel4 = new javax.swing.JLabel();
	javax.swing.JLabel JLabel5 = new javax.swing.JLabel();
	javax.swing.JLabel JLabel6 = new javax.swing.JLabel();
  javax.swing.JLabel JLabel7 = new javax.swing.JLabel();
	javax.swing.JTextField JEditOverlap = new javax.swing.JTextField();
	javax.swing.JButton JButtonOK = new javax.swing.JButton();
	javax.swing.JButton JButtonCancel = new javax.swing.JButton();
	javax.swing.JCheckBox JCheckBox1 = new javax.swing.JCheckBox();
	javax.swing.JCheckBox JCheckBox2 = new javax.swing.JCheckBox();
	//}}


	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == JButtonOK)
				JButtonOK_actionPerformed(event);
			else if (object == JButtonCancel)
				JButtonCancel_actionPerformed(event);
		}
	}

	void JButtonOK_actionPerformed(java.awt.event.ActionEvent event)
	{
		// OK
		this.setVisible(false);
		STA = (new Double(this.JEditSTA.getText())).doubleValue();
		LTA = (new Double(this.JEditLTA.getText())).doubleValue();
		SEUILMIN = (new Double(this.JEditMinThreshold.getText())).doubleValue();
		SEUILMAX = (new Double(this.JEditMaxThreshold.getText())).doubleValue();
		WIN_LENGTH = (new Double(this.JEditWinLength.getText())).doubleValue();
		OVERLAP = (new Double(this.JEditOverlap.getText())).doubleValue();
		SATURATION = JCheckBox1.isSelected();
		TRANSIENT = JCheckBox2.isSelected();
    TOLERANCE = (new Double(this.JEditTolerance.getText())).doubleValue();
	}
	
	public void setSTA(double val) {
	    STA = val;
	}
	
	public void setLTA(double val) {
	    LTA = val;
	}
	
	public void setMinThresold(double val) {
	    SEUILMIN = val;
	}
	
	public void setMaxThresold(double val) {
	    SEUILMAX = val;
	}
	
	public void setWindowLength(double val) {
	    WIN_LENGTH = val;
	}
	
	public void setOverlapPercentage(double val) {
	    OVERLAP = val;
	}
	
	public void setToleranceLevel(double val) {
	    TOLERANCE = val;
	}
	
	public void setSaturation(int val) {  if ( val == 0 ) SATURATION = false; else SATURATION = true; }
		
	public void setTransient(int val) { if ( val == 0 ) TRANSIENT = false; else TRANSIENT = true; }
///////////
	
	public double getSTA() {
	    return STA;
	}
	
	public double getLTA() {
	    return LTA;
	}
	
	public double getMinThresold() {
	    return SEUILMIN;
	}
	
	public double getMaxThresold() {
	    return SEUILMAX;
	}
	
	public double getWindowLength() {
	    return WIN_LENGTH;
	}
	
	public double getOverlapPercentage() {
	    return OVERLAP;
	}


	public double getToleranceLevel() {
	    return TOLERANCE;
	}

	public int isSaturation() { if (SATURATION) return 1; else return 0; }
	
	public int isTransient() { if (TRANSIENT) return 1; else return 0; }
	
	public void setInitValues()
	{		
		JEditSTA.setText(""+STA);
		JEditLTA.setText(""+LTA);
		JEditMinThreshold.setText(""+SEUILMIN);
		JEditMaxThreshold.setText(""+SEUILMAX);
		JEditWinLength.setText(""+WIN_LENGTH);
		JEditOverlap.setText(""+OVERLAP);
    JEditTolerance.setText(""+TOLERANCE);
		JCheckBox1.setSelected(SATURATION);
		JCheckBox2.setSelected(TRANSIENT);			 
	}
	
	void JButtonCancel_actionPerformed(java.awt.event.ActionEvent event)
	{
		// Cancel
		this.setVisible(false);
		setInitValues();
			 
	}
}