package Sesame2;



import java.io.*;

import java.awt.List;

import java.util.Calendar;

import java.util.Vector;



public class GSEFormatWaveform extends multipleWaveform  {

    

  java.awt.List listTraces = new List();

  int numberTraces=0;

  

  int getYearChannel(int k) {

     int line = getStartChannel(k); 

     listTraces.select(line);	   

	 return((new Integer(listTraces.getSelectedItem().substring(5,9).trim())).intValue());

   }

   

  int getMonthChannel(int k) {

     int line = getStartChannel(k); 

     listTraces.select(line);	   

	 return((new Integer(listTraces.getSelectedItem().substring(10,12).trim())).intValue());

   }

   

  int getDayChannel(int k) {

     int line = getStartChannel(k); 

     listTraces.select(line);	   

	 return((new Integer(listTraces.getSelectedItem().substring(13,15).trim())).intValue());

   }

   

  int getHourChannel(int k) {

    //get start hour of one channel

     int line = getStartChannel(k); 

	 char[] N = new char[3];

	 listTraces.select(line);	   

	 listTraces.getSelectedItem().getChars(16,18,N,0);

	 return( (new Integer((new String(N)).trim())).intValue());

   }

   

  int getMinuteChannel(int k) {

    //get start minute of one channel

    //line: start channel line (ascii line) of the list     

     int line = getStartChannel(k); 

	 char[] N = new char[3];

	 listTraces.select(line);	   

	 listTraces.getSelectedItem().getChars(19,21,N,0);

	 return( (new Integer((new String(N)).trim())).intValue());

   }

   

   double getSecChannel(int k) {

    //get start seconds of one channel

    //line: start channel line (ascii line) of the list

     int line = getStartChannel(k);

	 char[] N = new char[7];

	 listTraces.select(line);	   

	 listTraces.getSelectedItem().getChars(22,28,N,0);

	 return( (new Double((new String(N)).trim())).doubleValue());

   }

  

  float getFreqSample(int k) {

     // get sample frequency of one channel

     //line: start channel line (ascii line) of the list

     //JlistTraces: List which store the waveform

     int line = getStartChannel(k); 

	 char[] N = new char[12];

	 listTraces.select(line);	   

	 listTraces.getSelectedItem().getChars(57,68,N,0);

	 float freq = (new Float((new String(N)).trim())).floatValue();

	 return( freq );

	}



  int getNSampChannel(int k) {

	 // get number of sample of one channel

     //line: start channel line (ascii line) of the list

     //JlistTraces: List which store the waveform    

     int line = getStartChannel(k); 

	 char[] NSamp = new char[9];

	 listTraces.select(line);	   

	 listTraces.getSelectedItem().getChars(48,56,NSamp,0);

	 return( (new Integer((new String(NSamp)).trim())).intValue());	 	 

	}



  public String getNameChannel(int k) {

	 // get Name of channel of one channel from the waveform

     //line: start channel line (ascii line) of the list   

     int line = getStartChannel(k);

	 listTraces.select(line);	 

	 //return listTraces.getSelectedItem().substring(29,38).trim();

	 return listTraces.getSelectedItem().substring(35,38).trim();

	}



  public String getNameStationChannel(int k) {

	 // get Name of channel of one channel from the waveform

     //line: start channel line (ascii line) of the list   

     int line = getStartChannel(k);

	 listTraces.select(line);	 

	 return listTraces.getSelectedItem().substring(29,35).trim();

	}

	

  Vector getArrayValue(int k) {

    // Get the array value of the trace (Amplitudes)

    //JlistTraces : List of the waveform values

    //line : start line of the channel 

    // va : array values to be return

    //nsamples : number of samples 

    int i,n;

    int line = getStartChannelData(k);

    int nsamples = getNSampChannel(k);

    Vector val = new Vector();

    Vector inpval = new Vector();

	 line = line + 1;

	 int endchanelline = getEndChannel(k); 

	 while(line < endchanelline) {

	  listTraces.select(line);	   

	  //System.out.println(listTraces.getSelectedItem());

	  int l=listTraces.getSelectedItem().length();

	  char[] Samp = new char[l];

	  listTraces.getSelectedItem().getChars(0,l , Samp, 0);

	  for(i=0; i<l; ++i)

	    inpval.addElement(new Byte((byte)Samp[i]));

	  ++line;

	  }

	  n = DCOMP6(inpval,val);

	  REMDIF1(val,n);

	  REMDIF1(val,n);
    // removin offet zero
            double med=0;
            double max=((Double)(val.elementAt(0))).doubleValue();
            double min=max;
            for( i=0; i< n; ++i) 
            {
              if( max < ((Double)(val.elementAt(i))).doubleValue()) 
                  max = ((Double)(val.elementAt(i))).doubleValue();
              if( min > ((Double)(val.elementAt(i))).doubleValue())
                  min = ((Double)(val.elementAt(i))).doubleValue(); 
            }
            if ((max<0) || (min>0)) {
             med = (max + min)/2.0;
            }
           for( i=0; i< n; ++i) 
            {
              val.setElementAt(new Double(((Double)(val.elementAt(i))).doubleValue()-med), i);
            }

	  return val;

	}



   String getStrChnTime(int k) {

      int i = getStartChannel(k); 

      String cad = listTraces.getItem(i); 

        String time="";

        time=cad.substring(5,9)+cad.substring(10,12)

               +cad.substring(13,15)+cad.substring(16,18)

               +cad.substring(19,21)+cad.substring(22,28);

        return time.replace(' ','0');

    }

    

  int getStartChannel(int ch) {

	 // get start line of one channel from the list

     //ch: channel 

	 int nline = 0;	 

	 int j=-1;

	 while(nline < listTraces.getItemCount()) {

	 if (listTraces.getItem(nline).indexOf("WID2")!=-1 ) ++j; 

	 if( j==ch ) break;

	 ++nline;

	 }

	 return nline;

	}



   int getStartChannelData(int ch) {

	 // get start line of one channel from the list

     //ch: channel 

	 int nline = 0;	 

	 int j=-1;

	 while(nline < listTraces.getItemCount()) {

	 if (listTraces.getItem(nline).indexOf("DAT2")!=-1 ) ++j;

	 if( j==ch ) break;

	 ++nline;

	 }

	 return nline;

	}



  int getEndChannel(int ch) {

	 // get start line of one channel from the list

     //ch: channel 

	 int nline = 0;	 

	 int j=-1;

	 while(nline < listTraces.getItemCount()) {

	 if (listTraces.getItem(nline).indexOf("CHK2")!=-1 ) ++j; 

	 if( j==ch ) break;

	 ++nline;

	 }

	 return nline;

	}

	

	int  DCOMP6(Vector IBUF,Vector IOUT) {

       char[] ACHAR= new char[5];

 //      char TEST[] = {'1','2','3','4'};

       char ASPACE,LFEED,CRETN;

      int LOUT=0;

      int LB = IBUF.size();

      //EQUIVALENCE (INN,ACHAR),(ITEST,TEST)

      long ICHAR[] = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,

      0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,

      0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,2,

      3,4,5,6,7,8,9,10,11,0,0,0,0,0,0,0,

      12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,

      28,29,30,31,32,33,34,35,36,37,0,0,0,0,0,0,

      38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,

      54,55,56,57,58,59,60,61,62,63,0,0,0,0,0,0};

      CRETN = '\r';

      LFEED = '\n';

      ASPACE = ' ';

      //int IMAX = 1000;

      long ISIGN = 16;

      long IOFLOW = 32;

      long MASK1 = 15;

      long MASK2 = 31;

 //     WORK OUT WHICH WAY BYTES ARE STORED IN COMPUTER

      int IBYTE = 0;

      long INN=0;

 /*     long ITEST = (long)TEST[3];

      ITEST = ((ITEST << 8)|((long)TEST[2]))<<16;  

      long ITEST1 = (long)TEST[1];  

      ITEST1 = (ITEST1 << 8)|((long)TEST[0]);  

      ITEST = ITEST | ITEST1;

      if (ITEST==(((52*256+51)*256+50)*256+49)) IBYTE = 0;*/

      int ICOUNT = 0;

      int I = 0;

      int J = 0;

//     START OF DECODING

   do {

    do { 

	 ACHAR[IBYTE] = (char)((Byte)(IBUF.elementAt(I))).byteValue();

//       IF A CARRIAGE OR LINE FEED IGNORE, IF A SPACE THEN END OF DATA

      I = I + 1;

	}while( (ACHAR[IBYTE] == CRETN) ||  (ACHAR[IBYTE]==LFEED) );

	  

	if (ACHAR[IBYTE] == ASPACE) break;

	

	ICOUNT = ICOUNT + 1;

//      STRIP OFF ANY HIGHER ORDER BITS

     

     INN = (long)ACHAR[IBYTE];  

     /*long INN1 = (int)ACHAR[1];  

     INN1 = (INN1 << 8)|((int)ACHAR[0]);  

     INN = INN | INN1;*/

    

	 long K = INN & 127;

	

//       GET NUMBER REPRESENTION OF INPUT CHARACTER

	 INN = ICHAR[(int)K-1];

//       GET SIGN BIT

	 long JSIGN = INN & ISIGN;

//       GET CONTINUATION BIT (IF ANY)

	 long JOFLOW = INN & IOFLOW;

//       REMOVE BITS WE DONT WANT

	 long ITEMP = INN & MASK1;

	 

     while(JOFLOW!=0){    

	  //         THERE IS ANOTHER BYTE IN THIS SAMPLE

	  ITEMP = ITEMP * 32;

     do{

	     ACHAR[IBYTE] = (char)((Byte)(IBUF.elementAt(I))).byteValue();

	     I = I + 1;

	 }while( (ACHAR[IBYTE]==CRETN) || (ACHAR[IBYTE]==LFEED)); 

	  ICOUNT = ICOUNT + 1;

//         STRIP OFF ANY HIGHER ORDER BITS

      INN = (long)ACHAR[IBYTE];

	  K = INN & 127;

	  INN = ICHAR[(int)K-1];

//         GET CONTINUATION BIT (IF ANY)

	  JOFLOW = INN & IOFLOW;

	  K = INN & MASK2;

	  ITEMP = ITEMP + K;

	

	 }

	if (JSIGN!=0) ITEMP = -ITEMP;

	

	//if (J >= IMAX) break;

	//IOUT[J] = ITEMP;

//	  System.out.println(ICOUNT + "  " + J);

	  IOUT.addElement((new Double((double)ITEMP)));

	

	 J = J +1;

	}while(ICOUNT<LB);

     //System.out.println("END:" + J);

    LOUT = J;

       

/*    if (J > IMAX){

	  LOUT = IMAX;

	  return -1;

    }*/

      return LOUT;

   }

   

     void REMDIF1(Vector iy,int nmax) {



//     Remove Data-compression (first differences)

       int k;

       double sum;

       double val1,val2;

      for( k=1;k<nmax;++k) {

        val1 = ((Double)(iy.elementAt(k))).doubleValue();

        val2 = ((Double)(iy.elementAt(k-1))).doubleValue();

        sum = val1 + val2;

        iy.setElementAt(new Double(sum), k);

      }

      

 }

 



    int getStrYear(String cad) {

      return((new Integer(cad.substring(0,4))).intValue());  

    }

    

    int getStrMonth(String cad) {

      return((new Integer(cad.substring(4,6))).intValue());  

    }

    

    int getStrDay(String cad) {

      return((new Integer(cad.substring(6,8))).intValue());  

    }

    

    int getStrHour(String cad) {

      return((new Integer(cad.substring(8,10))).intValue());  

    }

    

    int getStrMin(String cad) {

      return((new Integer(cad.substring(10,12))).intValue());  

    }

    

    double getStrSec(String cad) {

      return((new Double(cad.substring(12,18))).doubleValue());  

    }



   double getabsTimeSec(int yy,int mm,int dd,int hh,int min,double sec) {

        Calendar rightNow = Calendar.getInstance();

        rightNow.set(yy,mm,dd,hh,min,(int)sec);

        return(((rightNow.getTime().getTime()/1000)*1000 + (int)((sec-(int)sec)*1000))/1000);

    }    

    

   double getabsTime(String cad) {

        return getabsTimeSec(getStrYear(cad),getStrMonth(cad),getStrDay(cad),getStrHour(cad),getStrMin(cad),getStrSec(cad));

    }

    

   void addNewChannel(int idx) {

     singleWaveform trace = new singleWaveform();

     trace.setYear(this.getYearChannel(idx));

     trace.setMonth(this.getMonthChannel(idx));

     trace.setDay(this.getDayChannel(idx));

     trace.setHour(this.getHourChannel(idx));

     trace.setMinute(this.getMinuteChannel(idx));

     trace.setSeconds(this.getSecChannel(idx));

     trace.setChannelName(this.getNameChannel(idx));

     trace.setStationName(this.getNameStationChannel(idx));

     trace.setSamplingFreq(this.getFreqSample(idx));

     trace.setAmplitudeType('C');

     trace.setDataPoints(this.getArrayValue(idx));

     this.addSingleTrace(trace);

     numberTraces++;

   }

   

   public int getYear() {

      return getStrYear(getInitTime());

   }

   

   public int getMonth() {

      return getStrMonth(getInitTime());

   }

   

   public int getDay() {

      return getStrDay(getInitTime());

   }

   

   public int getHour() {

      return getStrHour(getInitTime());

   }

   

   public int getMinute() {

      return getStrMin(getInitTime());

   }

   

   public double getSeconds() {

      return getStrSec(getInitTime());

   }

   

  public double getTotalTimeSec() {

        int i;

        int k=0;

        double max_time=0;

        double val;

        String cad1;

        while(k<numberTraces) {

            listTraces.select(getStartChannel(k)); 

            cad1=listTraces.getSelectedItem();

            val=(new Long(cad1.substring(48,56).trim())).longValue()/

                 (new Double(cad1.substring(57,68).trim())).doubleValue();

            val=val+getabsTime(getStrChnTime(k));

            if( val > max_time ) max_time=val;

          ++k;         

       } 

       return (max_time-getabsTime(getInitTime()));

    }    

    

   public String getInitTime() {

        // return "yyyymmddhhmmss.cc"

        int k=0;

        String min_time="90000000000000.000";

        String time="";

        while(k<numberTraces){

           time=getStrChnTime(k);

           if(time.compareTo(min_time)<0) min_time=time;

           ++k;

       } 

       return min_time;

    }

    

    public  double getFreqSampleMax() {

    // get max sample frequency among the traces

     return getFreqSample(0);

	/*    int k=0;

        double max_time=0;

        double val;

        String cad1;

        while(k<numberTraces){ 

            listTraces.select(getStartChannel(k)); 

            cad1=listTraces.getSelectedItem();

            val=(new Double(cad1.substring(57,68).trim())).doubleValue();

            if( val > max_time ) max_time=val;

            ++k;

        } 

       return max_time;*/

	 

	}

	

    public int loadFile(String filename) {

       int NCHN=0;

       String inputLine;

       filename = filename.replace('\"',' ');

       filename = filename.trim();

       listTraces.removeAll();

       System.out.println("Reading the output file..."+filename); 

	   try {

	   FileInputStream fileIn = new FileInputStream(filename);

	   BufferedReader in = new BufferedReader(

				new InputStreamReader(fileIn));  

	   while ( ((inputLine = in.readLine()) != null)) {

	      listTraces.add(inputLine);

	      if (inputLine.indexOf("DAT2")!=-1 ) ++NCHN;

	   }

	    //System.out.println(inputLine);   

	   int i = 0;

	   while( i < NCHN ) {

          addNewChannel(i);

          ++i;

       } 

       in.close();

       System.out.println("done");

       } catch (IOException Ex)

        {

            System.out.println(Ex.getMessage());

            return -1;

        }

        return 0;

    }



    public  int loadHeader(String filename) {

       int NCHN=0;

       String inputLine;

       filename = filename.replace('\"',' ');

       filename = filename.trim();

       listTraces.removeAll();

       System.out.println("Reading the output file header..."+filename);

	   try {

	   FileInputStream fileIn = new FileInputStream(filename);

	   BufferedReader in = new BufferedReader(

				new InputStreamReader(fileIn));  

	   while ( ((inputLine = in.readLine()) != null)) {

	      if (inputLine.indexOf("WID2")!=-1 ) {

             listTraces.add(inputLine);

             listTraces.add("CHK2");

	   }

	   }

       in.close();

       System.out.println("done");

       } catch (IOException Ex)

        {

            System.out.println(Ex.getMessage());

            return -1;

        }

        return 0;

    }



    public int saveFile(String filename) {

        return 0;

    }

    

}