package SesameGUI;

import java.awt.Dimension;

import oracle.jdeveloper.layout.VerticalFlowLayout;

import oracle.jdeveloper.layout.XYLayout;

import javax.swing.JButton;

import oracle.jdeveloper.layout.XYConstraints;

import javax.swing.JComboBox;

import javax.swing.JLabel;

import javax.swing.ComboBoxModel;

import javax.swing.JEditorPane;

import javax.swing.JTextField;

import javax.swing.DefaultComboBoxModel;

import java.awt.event.ActionListener;

import java.awt.event.ActionEvent;

import javax.swing.JTextArea;



public class ParametersDlg extends javax.swing.JDialog

{

  private ProcessingParameters processingParameters;

  private XYLayout xYLayout1 = new XYLayout();

  private JButton ok = new JButton();

  private JButton cancel = new JButton();

  private JComboBox freqSpacing = new JComboBox();

  private JLabel jLabel1 = new JLabel();

  private JLabel freq1l = new JLabel();

  private JLabel freq2l = new JLabel();

  private JLabel freq3l = new JLabel();

  private FloatField freqMin = new FloatField((float)0.5, 0);

  private FloatField freqMax = new FloatField((float)25.0, 0);

  private IntField numberPoints = new IntField(250 , 0);

  private JLabel jLabel2 = new JLabel();

  private JLabel jLabel3 = new JLabel();

//  private JLabel jLabel4 = new JLabel();

  private JLabel jLabel5 = new JLabel();

  private JLabel jLabel6 = new JLabel();

//  private JLabel jLabel7 = new JLabel();

//  private JLabel jLabel8 = new JLabel();

  private JLabel jLabel9 = new JLabel();

  private JComboBox offsetRemoval = new JComboBox();

  private FloatField freqOr = new FloatField((float)0.0, 0);

  private JLabel freqOrl = new JLabel();

  private JComboBox tapering = new JComboBox();

  private JLabel percTl = new JLabel();

  private FloatField percT = new FloatField((float)0.0, 0);

  private JComboBox instrumentCorrection = new JComboBox();

  private JComboBox smoothing = new JComboBox();

  private JLabel arg2Sl = new JLabel();

  private FloatField freqMin1 = new FloatField((float)1.0, 0);

  private JLabel arg1Sl = new JLabel();

  private JComboBox smoothingType = new JComboBox();

  private JComboBox merging = new JComboBox();

  private JComboBox outputSingleComponents = new JComboBox();

  private JComboBox average = new JComboBox();

  private JComboBox outputSingleWindow = new JComboBox();

  

  public ParametersDlg(ProcessingParameters pp)

  {

    processingParameters = pp;

    

    try

    {

      jbInit();

    }

    catch(Exception e)

    {

      e.printStackTrace();

    }

  }



  private void jbInit() throws Exception

  {

    this.setTitle("Processing parameters");

    this.getContentPane().setLayout(xYLayout1);

    xYLayout1.setWidth(594);

    xYLayout1.setHeight(299);

    ok.setText("OK");

    ok.setActionCommand("ok");

    ok.addActionListener(new ActionListener()

      {

        public void actionPerformed(ActionEvent e)

        {

          okActionPerformed(e);

        }

      });

    cancel.setText("Cancel");

    cancel.addActionListener(new ActionListener()

      {

        public void actionPerformed(ActionEvent e)

        {

          cancelActionPerformed(e);

        }

      });

    freqSpacing.addActionListener(new ActionListener()

      {

        public void actionPerformed(ActionEvent e)

        {

          freqSpacingChanged(e);

        }

      });

    jLabel1.setText("Freq. spacing:");

    freq1l.setText("Freq. min:");

    freq2l.setText("Freq. max:");

    freq3l.setText("# points:");

    jLabel2.setText("Offset removal:");

    jLabel3.setText("Tapering:");

//    jLabel4.setText("Instrument correction:");

    jLabel5.setText("Smoothing:");

    jLabel6.setText("Merging:");

//    jLabel7.setText("Output single components:");

//    jLabel8.setText("Average:");

    jLabel9.setText("Output single window information:");

    offsetRemoval.addActionListener(new ActionListener()

      {

        public void actionPerformed(ActionEvent e)

        {

          offsetRemovalChanged(e);

        }

      });

    freqOrl.setText("Freq.:");

    tapering.addActionListener(new ActionListener()

      {

        public void actionPerformed(ActionEvent e)

        {

          taperingChanged(e);

        }

      });

    percTl.setText("Perc.:");

    smoothing.addActionListener(new ActionListener()

      {

        public void actionPerformed(ActionEvent e)

        {

          smoothingChanged(e);

        }

      });

    arg2Sl.setText("Type:");

    arg1Sl.setText("Bandwidth:");

    this.getContentPane().add(outputSingleWindow, new XYConstraints(240, 185, 70, 20));

    this.getContentPane().add(average, new XYConstraints(95, 180, 80, 20));

    this.getContentPane().add(outputSingleComponents, new XYConstraints(200, 155, 70, 20));

    this.getContentPane().add(merging, new XYConstraints(95, 130, 80, 20));

    this.getContentPane().add(smoothingType, new XYConstraints(415, 105, 80, 20));

    this.getContentPane().add(arg1Sl, new XYConstraints(220, 105, 105, 15));

    this.getContentPane().add(freqMin1, new XYConstraints(290, 105, 40, 20));

    this.getContentPane().add(arg2Sl, new XYConstraints(360, 105, 90, 15));

    this.getContentPane().add(smoothing, new XYConstraints(95, 105, 80, 20));

    this.getContentPane().add(instrumentCorrection, new XYConstraints(175, 80, 70, 20));

    this.getContentPane().add(percT, new XYConstraints(290, 55, 40, 20));

    this.getContentPane().add(percTl, new XYConstraints(250, 55, 90, 15));

    this.getContentPane().add(tapering, new XYConstraints(95, 55, 80, 20));

    this.getContentPane().add(freqOrl, new XYConstraints(250, 30, 75, 15));

    this.getContentPane().add(freqOr, new XYConstraints(290, 30, 40, 20));

    this.getContentPane().add(offsetRemoval, new XYConstraints(95, 30, 80, 20));

    this.getContentPane().add(jLabel9, new XYConstraints(5, 185, 230, 20));

//    this.getContentPane().add(jLabel8, new XYConstraints(5, 180, 100, 20));

//    this.getContentPane().add(jLabel7, new XYConstraints(5, 155, 210, 20));

    this.getContentPane().add(jLabel6, new XYConstraints(5, 130, 95, 20));

    this.getContentPane().add(jLabel5, new XYConstraints(5, 105, 95, 20));

//    this.getContentPane().add(jLabel4, new XYConstraints(5, 80, 155, 20));

    this.getContentPane().add(jLabel3, new XYConstraints(5, 55, 90, 20));

    this.getContentPane().add(jLabel2, new XYConstraints(5, 30, 110, 20));

    this.getContentPane().add(numberPoints, new XYConstraints(540, 5, 40, 20));

    this.getContentPane().add(freqMax, new XYConstraints(415, 5, 40, 20));

    this.getContentPane().add(freqMin, new XYConstraints(290, 5, 40, 20));

    this.getContentPane().add(freq3l, new XYConstraints(490, 5, 55, 15));

    this.getContentPane().add(freq2l, new XYConstraints(345, 5, 80, 15));

    this.getContentPane().add(freq1l, new XYConstraints(230, 5, 85, 15));

    this.getContentPane().add(jLabel1, new XYConstraints(5, 5, 120, 20));

    this.getContentPane().add(freqSpacing, new XYConstraints(95, 5, 124, 20));

    this.getContentPane().add(cancel, new XYConstraints(465, 240, 73, 27));

    this.getContentPane().add(ok, new XYConstraints(40, 240, 73, 27));

    smoothingType.setModel(new DefaultComboBoxModel(new String[] {"box", "tri"}));

    smoothingType.setSelectedItem(processingParameters.sm_arg2);
    smoothing.setModel(new DefaultComboBoxModel(new String[] {"none", "linear", "konno-ohmachi"}));
    smoothing.setSelectedItem(processingParameters.sm_smoothing);
    freqSpacing.setModel (new javax.swing.DefaultComboBoxModel(new String[] { "fft", "fft_red", "linear", "log" }));
    freqSpacing.setSelectedItem(processingParameters.f_freqSpacing);

    offsetRemoval.setModel (new javax.swing.DefaultComboBoxModel(new String[] { "no", "r_mean", "high-pass" }));

    offsetRemoval.setSelectedItem(processingParameters.or_offsetRemoval);

    tapering.setModel (new javax.swing.DefaultComboBoxModel(new String[] { "box", "cos" }));

    tapering.setSelectedItem(processingParameters.tp_tappering);

    instrumentCorrection.setModel (new javax.swing.DefaultComboBoxModel(new String[] { "yes", "no" }));

    instrumentCorrection.setVisible(false);

    instrumentCorrection.setSelectedItem(processingParameters.instrumentResponse);

    merging.setModel(new DefaultComboBoxModel(new String[] {"arithmetic", "geometric", "quadratic","complex"}));

    merging.setSelectedItem(processingParameters.merging);

    outputSingleComponents.setModel(new DefaultComboBoxModel(new String[] {"yes", "no"}));

    outputSingleComponents.setSelectedItem(processingParameters.outSingleComp);

    outputSingleComponents.setVisible(false);

    average.setModel(new DefaultComboBoxModel(new String[] {"linear", "log"}));

    average.setVisible(false);

    average.setSelectedItem(processingParameters.average);

    outputSingleWindow.setModel(new DefaultComboBoxModel(new String[] {"yes", "no"}));

    outputSingleWindow.setSelectedItem(processingParameters.outSingleWindows);



    freqMin.setMinVal(0.0f);

    freqMin.setMaxVal(10000.0f);

    freqMin.setText(processingParameters.f_arg1);

    freqMax.setMinVal(0.0f);

    freqMax.setMaxVal(10000.0f);

    freqMax.setText(processingParameters.f_arg2);



    freqOr.setMinVal(0.0f);

    freqOr.setMaxVal(10000.0f);

    freqOr.setText(processingParameters.or_arg1);

    

    freqMin1.setMinVal(0.0f);

    freqMin1.setMaxVal(10000.0f);

    freqMin1.setText(processingParameters.sm_arg1);



    percT.setMinVal(0.0f);

    percT.setMaxVal(100.0f);

    percT.setText(processingParameters.tp_arg1);



    numberPoints.setMinVal(0);

    numberPoints.setMaxVal(1000000);

    numberPoints.setText(processingParameters.f_arg3);



    this.setSize(593 , 307);

  }



  private void freqSpacingChanged(ActionEvent e)

  {

  switch (freqSpacing.getSelectedIndex ())

    {

      case  0:

        freq1l.setVisible(false);

        freq2l.setVisible(false);

        freq3l.setVisible(false);

        freqMin.setVisible(false);

        freqMax.setVisible(false);

        numberPoints.setVisible(false);

        break;



      case  1:

        freq1l.setVisible(true);

        freq2l.setVisible(true);

        freq3l.setVisible(false);

        freqMin.setVisible(true);

        freqMax.setVisible(true);

        numberPoints.setVisible(false);

        break;



      case  2:

        freq1l.setVisible(true);

        freq2l.setVisible(true);

        freq3l.setVisible(true);

        freqMin.setVisible(true);

        freqMax.setVisible(true);

        numberPoints.setVisible(true);

        break;



      case  3:

        freq1l.setVisible(true);

        freq2l.setVisible(true);

        freq3l.setVisible(true);

        freqMin.setVisible(true);

        freqMax.setVisible(true);

        numberPoints.setVisible(true);

        break;

    }



    repaint(100);

  }



  private void offsetRemovalChanged(ActionEvent e)

  {

    switch (offsetRemoval.getSelectedIndex())

    {

    case    0:

      freqOr.setVisible(false);

      freqOrl.setVisible(false);      

      break;



    case    1:

      freqOr.setVisible(false);

      freqOrl.setVisible(false);      

      break;



    case    2:

      freqOr.setVisible(true);

      freqOrl.setVisible(true);

      break;

    }

      

    repaint(100);

  }



  private void taperingChanged(ActionEvent e)

  {

    if (tapering.getSelectedIndex()==0)

    {

    percT.setVisible(false);

    percTl.setVisible(false);

    }

    else

    {

    percT.setVisible(true);

    percTl.setVisible(true);

    }



    repaint();

  }



  private void smoothingChanged(ActionEvent e)

  {

  switch (smoothing.getSelectedIndex ())

    {

      case  0:

        arg1Sl.setVisible(false);

        arg2Sl.setVisible(false);

        freqMin1.setVisible(false);

        smoothingType.setVisible(false);

        break;



      case  1:

        arg1Sl.setVisible(true);

        arg1Sl.setText("Bandwidth:");

        arg2Sl.setVisible(true);

        freqMin1.setVisible(true);

        freqMin1.setText("1.0");

        smoothingType.setVisible(true);

        break;

      /*case  2:
        arg1Sl.setVisible(true);

        arg1Sl.setText("Percentage:");

        arg2Sl.setVisible(true);

        freqMin1.setVisible(true);

        smoothingType.setVisible(true);
        break;*/

      case  2:
        arg1Sl.setVisible(true);

        arg1Sl.setText("Bandwidth:");

        arg2Sl.setVisible(false);

        freqMin1.setVisible(true);
        freqMin1.setText("40.0");
        smoothingType.setVisible(false);

        break;

    }

    

    repaint();

  }



  private void okActionPerformed(ActionEvent e)

  {

  processingParameters.f_freqSpacing = (String) freqSpacing.getSelectedItem();

  processingParameters.f_arg1 = freqMin.getText();

  processingParameters.f_arg2 = freqMax.getText();

  processingParameters.f_arg3 = numberPoints.getText();



  processingParameters.or_offsetRemoval = (String) offsetRemoval.getSelectedItem();

  processingParameters.or_arg1 = freqOr.getText();



  processingParameters.tp_tappering = (String) tapering.getSelectedItem();

  processingParameters.tp_arg1 = percT.getText();



  processingParameters.instrumentResponse = (String) instrumentCorrection.getSelectedItem();



  processingParameters.sm_smoothing = (String) smoothing.getSelectedItem();

  processingParameters.sm_arg1 = freqMin1.getText();

  processingParameters.sm_arg2 = (String) smoothingType.getSelectedItem();



  processingParameters.merging = (String) merging.getSelectedItem();



  processingParameters.outSingleComp = (String) outputSingleComponents.getSelectedItem();



  processingParameters.average = (String) average.getSelectedItem();



  processingParameters.outSingleWindows = (String) outputSingleWindow.getSelectedItem();

  

  dispose();

  }



  private void cancelActionPerformed(ActionEvent e)

  {

  dispose();

  }

}