package SesameGUI;

import java.awt.*;
import java.awt.geom.*;

public class Scale 
	{
	public Scale(SpectrumView view)
		{
		upperBound = 0.0;
		lowerBound = 0.0;
		upperVisibleBound = 0.0;
		lowerVisibleBound = 0.0;
		step = 0.0;

    showGrid = false;
    boxScale = false;

		label = new String();

		this.view = view;
		}

  public double getOrigOffset()
    {
    return view.getOrigOffset();    
    }

  public double getSamplingRate()
    {
    return view.getSamplingRate();    
    }

  public double getTicker(int ndx)
    {
    return view.getTicker(ndx);    
    }

  public boolean isLog()
    {
    return view.isLog();    
    }

	public void draw(Graphics2D g)
		{
		}

	public double getLowerVisibleBound()
		{
		return lowerVisibleBound;
		}

	public void setLowerVisibleBound(double lowerVisibleBound)
		{
		this.lowerVisibleBound = lowerVisibleBound;
		}

	public double getLowerBound()
		{
		return lowerBound;
		}

	public void setLowerBound(double lowerBound)
		{
		this.lowerBound = lowerBound;
		}

	public double getUpperVisibleBound()
		{
		return upperVisibleBound;
		}

	public void setUpperVisibleBound(double upperVisibleBound)
		{
		this.upperVisibleBound = upperVisibleBound;
		}

	public double getUpperBound()
		{
		return upperBound;
		}

	public void setUpperBound(double upperBound)
		{
		this.upperBound = upperBound;
		}

	public double getStep()
		{
		return step;
		}

	public void setStep(double step)
		{
		this.step = step;
		}

	public double getLength()
		{
		return upperVisibleBound - lowerVisibleBound;
		}

	public void calcStep(int numberOfSteps)
		{
    if (numberOfSteps > 20)
      {
      numberOfSteps = 20;

      step = Math.round(((upperVisibleBound - lowerVisibleBound) * 10.0) / numberOfSteps) / 10.0;
      }
    else
  		step = (upperVisibleBound - lowerVisibleBound) / numberOfSteps;
		}

  public void calcStep()
		{
    int numberOfSteps;

    numberOfSteps = (int) (getLength() / 0.5);

    calcStep (numberOfSteps);
		}

	public void pane2Real(DoubleWrapper paneCoord)
		{
		}

	public void real2PaneAbsolute(DoubleWrapper realCoord)
		{
		}

	public void real2Pane(DoubleWrapper realCoord)
		{
		}

	public double getOrigin()
		{
		return 0.0;
		}

	public SpectrumView getView()
		{
		return view;
		}

	public double getFactor()
		{
		return factor;
		}

	public void setFactor(double factor)
		{
		this.factor = factor;
		}

	public String getLabel()
		{
		return label;
		}

	public void setLabel(String label)
		{
		this.label = label;
		}

  public void copyFrom(Scale other)
    {
    this.lowerVisibleBound = other.lowerVisibleBound;
    this.lowerBound = other.lowerBound;
    this.upperVisibleBound = other.upperVisibleBound;
    this.upperBound = other.upperBound;
    this.step = other.step;
    this.view = other.view;
    this.factor = other.factor;
    this.label = other.label;
    this.boxScale = other.boxScale;
    this.showGrid = other.showGrid;
    }

	public boolean isBoxScale(){ return boxScale; }

	public void setBoxScale(boolean boxScale){ this.boxScale = boxScale; }

	public boolean isShowGrid(){ return showGrid; }

	public void setShowGrid(boolean showGrid){ this.showGrid = showGrid; }

	private double lowerVisibleBound;
	private double lowerBound;
	private double upperVisibleBound;
	private double upperBound;
	private double step;
	private SpectrumView view;
	private double factor;
	private String label;
	private boolean boxScale;
	private boolean showGrid;
	}

