/* Generated by Together */

package SesameGUI;

import java.io.*;

public class SpectrumFileReader
	{
	public SpectrumFileReader(StreamTokenizer streamTokenizer, Spectrum spectra)
		{
		this.streamTokenizer = streamTokenizer;

		this.spectra = spectra;
		}

	public boolean read()
		{
		boolean ret;

		ret = false;

		try
			{
			String name;
			double value;
			int numberOfSamples;
			int i;

			name = new String("");

			streamTokenizer.parseNumbers();
			streamTokenizer.wordChars(33, 255);
			streamTokenizer.whitespaceChars(1, 32);
			streamTokenizer.eolIsSignificant(true);

			// read station name
			streamTokenizer.nextToken();
			streamTokenizer.nextToken();
			streamTokenizer.nextToken();

			name = streamTokenizer.sval;

			streamTokenizer.nextToken(); // nl

			// read component
			streamTokenizer.nextToken();
			streamTokenizer.nextToken();
			streamTokenizer.nextToken();

			name += "  ";
			name += streamTokenizer.sval;
			spectra.setName(name);
			streamTokenizer.nextToken(); // nl

			// read sampling rate
			streamTokenizer.nextToken();
			streamTokenizer.nextToken();
			streamTokenizer.nextToken();

			spectra.setSamplingRate(streamTokenizer.nval);
			streamTokenizer.nextToken(); // nl

			// read number of samples
			streamTokenizer.nextToken();
			streamTokenizer.nextToken();
			streamTokenizer.nextToken();

			numberOfSamples = (int)streamTokenizer.nval;
			streamTokenizer.nextToken(); // nl

			spectra.setSize(numberOfSamples);

			// read x samples
			for (i = 0; i < numberOfSamples; )
				{
				if (streamTokenizer.nextToken() == StreamTokenizer.TT_NUMBER)
					{
					spectra.add(streamTokenizer.nval);
					i++;
					}
				}

			ret = true;
			streamTokenizer.nextToken(); // nl
			}
		catch (Exception e)
			{
			}

		return ret;
		}

	private StreamTokenizer streamTokenizer;
	private Spectrum spectra;
	}

