package SesameGUI;

import java.io.*;

public class WindowFileReader
	{
	public WindowFileReader(String fileName , String dataFileName , Spectrum spectra)
		{
    this.dataFileName = dataFileName;
    
    if(fileName!=null) {
        fileName = fileName.replace('\"',' ');
        fileName = fileName.trim();
    }
		try
        	{
        	reader = new FileReader(fileName);
	        }
        catch (Exception e)
			{
            reader = null;
			}

		this.spectra = spectra;
		}

    
	public boolean read()
		{
		boolean ret;

		ret = false;

        if (reader == null)
            return ret;

		try
			{
			StreamTokenizer streamTokenizer;
			double 	value , sr;
			String	fName;
			String str1,str2;

      //sr = 10000.0; 
      sr = spectra.getSamplingRate ()*spectra.getSamplingRate ();
		
			streamTokenizer = new StreamTokenizer(reader);

			streamTokenizer.parseNumbers();
			streamTokenizer.wordChars(33, 255);
			streamTokenizer.whitespaceChars(1, 32);
			streamTokenizer.eolIsSignificant(true);

			while (streamTokenizer.nextToken() != StreamTokenizer.TT_EOF)
				{
				fName = streamTokenizer.sval;
         // System.out.println(fName);
          str2 = dataFileName.replace('\\', '/');
         // System.out.println(dataFileName);
          streamTokenizer.nextToken();

          while (streamTokenizer.ttype != StreamTokenizer.TT_NUMBER)
            {
                    fName += " " + streamTokenizer.sval;

	                streamTokenizer.nextToken();
            }

        str1 = fName.replace('\\', '/');

				value = streamTokenizer.nval * sr;

				streamTokenizer.nextToken();

                if (str1.equalsIgnoreCase(str2)) {
                    //System.out.println("equal");
					spectra.getWindows().add(value, streamTokenizer.nval * sr);
		        }
		        streamTokenizer.nextToken();// constant 1
		        streamTokenizer.nextToken(); // chZ
                chanelZ = streamTokenizer.sval;
                streamTokenizer.nextToken(); // chNS
                chanelNS = streamTokenizer.sval;
                streamTokenizer.nextToken(); // chEW
                chanelEW = streamTokenizer.sval;
                streamTokenizer.nextToken(); // Station
                station = streamTokenizer.sval;
                while (streamTokenizer.nextToken() != StreamTokenizer.TT_EOL);
				}

			ret = true;
			}
		catch (Exception e)
			{
			}

		return ret;
		}

    public String getZname() { return chanelZ; }
    public String getNSname() { return chanelNS; }
    public String getEWname() { return chanelEW; }
    public String getStationname() { return station; }
	private Reader reader;
    private String dataFileName;
	private Spectrum spectra;
	private String chanelZ="V";
	private String chanelNS="NS";
	private String chanelEW="EW";
	private String station="TEST";
	}

